Index: trunk/zoo-kernel/service_internal.c
===================================================================
--- trunk/zoo-kernel/service_internal.c	(revision 8)
+++ trunk/zoo-kernel/service_internal.c	(revision 9)
@@ -74,359 +74,75 @@
 }
 
-
-void printProcessResponse1(maps* m,map* request, int pid,service* serv,char* service,int status,maps* inputs,maps* outputs){
-  if(getpid()==pid)
-    printf("Content-Type: text/xml; charset=utf-8\r\nStatus: 200 OK\r\n\r\n");  
+char *zCapitalize1(char *tmp){
+        char *res=strdup(tmp);
+        if(res[0]>=97 && res[0]<=122)
+                res[0]-=32;
+        return res;
+}
+
+char *zCapitalize(char *tmp){
+  int i=0;
+  char *res=strdup(tmp);
+  for(i=0;i<strlen(res);i++)
+    if(res[i]>=97 && res[i]<=122)
+      res[i]-=32;
+  return res;
+}
+
+
+int zooXmlSearchForNs(char* name){
+  int i;
+  int res=-1;
+  for(i=0;i<nbNs;i++)
+    if(strncasecmp(name,nsName[i],strlen(nsName[i]))==0){
+      res=i;
+      break;
+    }
+  return res;
+}
+
+int zooXmlAddNs(xmlNodePtr nr,char* url,char* name){
+#ifdef DEBUG
+  fprintf(stderr,"zooXmlAddNs %d \n",nbNs);
+#endif
+  int currId=-1;
+  if(nbNs==0){
+    nbNs++;
+    currId=0;
+    nsName[currId]=strdup(name);
+    usedNs[currId]=xmlNewNs(nr,BAD_CAST url,BAD_CAST name);
+  }else{
+    currId=zooXmlSearchForNs(name);
+    if(currId<0){
+      nbNs++;
+      currId=nbNs-1;
+      nsName[currId]=strdup(name);
+      usedNs[currId]=xmlNewNs(nr,BAD_CAST url,BAD_CAST name);
+    }
+  }
+  return currId;
+}
+
+void zooXmlCleanupNs(){
+  int j;
+#ifdef DEBUG
+  fprintf(stderr,"zooXmlCleanup %d\n",nbNs);
+#endif
+  for(j=nbNs-1;j>=0;j--){
+#ifdef DEBUG
+    fprintf(stderr,"zooXmlCleanup %d\n",j);
+#endif
+    if(j==0)
+      xmlFreeNs(usedNs[j]);
+    free(nsName[j]);
+    nbNs--;
+  }
+  nbNs=0;
+}
+
+xmlNodePtr printGetCapabilitiesHeader(xmlDocPtr doc,char* service,maps* m){
+
   xmlNsPtr ns,ns_ows,ns_xlink,ns_xsi;
-  xmlNodePtr nr,n,nc,nc1,nc2,nc3,pseudor;
-  xmlDocPtr doc;
-  xmlChar *xmlbuff;
-  int buffersize;
-  time_t time1;  
-  time(&time1);
-  /**
-   * Create the document and its temporary root.
-   */
-  doc = xmlNewDoc(BAD_CAST "1.0");
-  pseudor = xmlNewNode(ns, BAD_CAST "root");
-  ns_ows=xmlNewNs(pseudor,BAD_CAST "http://www.opengis.net/ows/1.1",BAD_CAST "ows");
-  nr = xmlNewNode(ns, BAD_CAST "root");
-  ns=xmlNewNs(nr,BAD_CAST "http://www.opengis.net/wps/1.0.0",BAD_CAST "wps");
-
-  maps* tmp_maps=getMaps(m,"main");
-  if(tmp_maps!=NULL){
-    map* tmp=getMap(tmp_maps->content,"encoding");
-    if(tmp!=NULL){
-      doc->encoding = xmlCharStrdup(tmp->value);
-    }
-    else
-      doc->encoding = xmlCharStrdup("UTF-8");
-  }
-  
-  n = xmlNewNode(ns, BAD_CAST "ExecuteResponse");  
-  xmlNewNs(n,BAD_CAST "http://www.opengis.net/ows/1.1",BAD_CAST "ows");
-  xmlNewNs(n,BAD_CAST "http://www.opengis.net/wps/1.0.0",BAD_CAST "wps");
-  xmlNewNs(n,BAD_CAST "http://www.w3.org/1999/xlink",BAD_CAST "xlink");
-  xmlNewNs(n,BAD_CAST "http://www.w3.org/2001/XMLSchema-instance",BAD_CAST "xsi");
-  xmlNewProp(n,BAD_CAST "xsi:schemaLocation",BAD_CAST "http://www.opengis.net/wps/1.0.0 http://schemas.opengis.net/wps/1.0.0/wpsExecute_response.xsd");
-  xmlNewProp(n,BAD_CAST "service",BAD_CAST "WPS");
-  xmlNewProp(n,BAD_CAST "version",BAD_CAST "1.0.0");
-  xmlNewProp(n,BAD_CAST "xml:lang",BAD_CAST "en");
-  char tmp[256];
-  char url[256];
-  memset(tmp,0,256);
-  memset(url,0,256);
-  if(tmp_maps!=NULL){
-    map* tmpm=getMap(tmp_maps->content,"serverAddress");
-    map* tmpm1=getMap(tmp_maps->content,"tmpUrl");
-    if(tmpm!=NULL && tmpm1!=NULL){
-      sprintf(url,"%s/%s/%s_%i.xml",tmpm->value,tmpm1->value,service,pid);
-    }
-	if(tmpm1!=NULL)
-      sprintf(tmp,"%s/",tmpm->value);
-  }
-
-  xmlNewProp(n,BAD_CAST "serviceInstance",BAD_CAST tmp);
-  if(status!=SERVICE_SUCCEEDED){
-    xmlNewProp(n,BAD_CAST "statusLocation",BAD_CAST url);
-  }
-
-  nc = xmlNewNode(ns, BAD_CAST "Process");
-  map* tmp2=getMap(serv->content,"processVersion");
-
-  if(tmp2!=NULL)
-    xmlNewProp(nc,BAD_CAST "wps:processVersion",BAD_CAST tmp2->value);
-  
-  printDescription(nc,ns_ows,serv->name,serv->content);
-  fflush(stderr);
-
-  xmlAddChild(n,nc);
-
-  nc = xmlNewNode(ns, BAD_CAST "Status");
-  const struct tm *tm;
-  size_t len;
-  time_t now;
-  char *tmp1;
-  
-  now = time ( NULL );
-  tm = localtime ( &now );
-
-  tmp1 = new char[TIME_SIZE];
-
-  len = strftime ( tmp1, TIME_SIZE, "%Y-%m-%dT%I:%M:%SZ", tm );
-
-  switch(status){
-  case SERVICE_SUCCEEDED:
-    xmlNewProp(nc,BAD_CAST "creationTime",BAD_CAST tmp1);
-    nc1 = xmlNewNode(ns, BAD_CAST "ProcessSucceeded");
-    break;
-  case SERVICE_STARTED:
-    xmlNewProp(nc,BAD_CAST "creationTime",BAD_CAST tmp1);
-    nc1 = xmlNewNode(ns, BAD_CAST "ProcessStarted");
-    xmlNewProp(nc1,BAD_CAST "percentCompleted",BAD_CAST "NEED_SERVICE_ACCESS"); 
-    break;
-  case SERVICE_ACCEPTED:
-    xmlNewProp(nc,BAD_CAST "creationTime",BAD_CAST tmp1);
-    nc1 = xmlNewNode(ns, BAD_CAST "ProcessAccepted");
-    break;
-  case SERVICE_FAILED:
-    nc1 = xmlNewNode(ns, BAD_CAST "ProcessFailed");
-    break;
-  default :
-    printf("error code not know : %i\n",status);
-    exit(1);
-    break;
-  }
-  xmlAddChild(nc,nc1);
-  xmlAddChild(n,nc);
-
-#ifdef DEBUG
-  fprintf(stderr,"printProcessResponse 1 161\n");
-#endif
-
-  map* lineage=getMap(request,"lineage");
-  if(lineage!=NULL){
-    nc = xmlNewNode(ns, BAD_CAST "DataInputs");
-    int i;
-    maps* mcursor=inputs;
-    elements* scursor=serv->inputs;
-    while(mcursor!=NULL && scursor!=NULL){
-      printIOType1(doc,nc,ns,ns_ows,scursor,mcursor,"Input");
-      mcursor=mcursor->next;
-      scursor=scursor->next;
-    }
-    xmlAddChild(n,nc);
-    
-#ifdef DEBUG
-    fprintf(stderr,"printProcessResponse 1 177\n");
-#endif
-
-    nc = xmlNewNode(ns, BAD_CAST "OutputDefinitions");
-    mcursor=outputs;
-    scursor=serv->outputs;
-    while(mcursor!=NULL /*&& scursor!=NULL*/){
-      printOutputDefinitions1(doc,nc,ns,ns_ows,scursor,mcursor,"Output");
-      mcursor=mcursor->next;
-      //scursor=scursor->next;
-    }
-    xmlAddChild(n,nc);
-  }
-#ifdef DEBUG
-  fprintf(stderr,"printProcessResponse 1 190\n");
-#endif
-
-  /**
-   * Display the process output only when requested !
-   */
-  if(status==SERVICE_SUCCEEDED){
-    nc = xmlNewNode(ns, BAD_CAST "ProcessOutputs");
-    maps* mcursor=outputs;
-    elements* scursor=serv->outputs;
-    while(mcursor!=NULL/* && scursor!=NULL*/){
-      //xmlAddChild(nc,xmlNewComment(BAD_CAST "Here we need to check for output format from metadata"));
-      printIOType1(doc,nc,ns,ns_ows,scursor,mcursor,"Output");
-      mcursor=mcursor->next;
-      //scursor=scursor->next;
-    }
-    xmlAddChild(n,nc);
-  }
-#ifdef DEBUG
-  fprintf(stderr,"printProcessResponse 1 202\n");
-#endif
-
-  xmlAddChild(nr,n);
-  xmlDocSetRootElement(doc, n);
-
-  /*
-   * Dump the document to a buffer and print it
-   * for demonstration purposes.
-   */
-  xmlDocDumpFormatMemory(doc, &xmlbuff, &buffersize, 1);
-  printf((char *) xmlbuff);
-  
-  /*
-   * Free associated memory.
-   */
-  xmlFree(xmlbuff);
-  xmlFree(nr);
-  xmlFreeDoc(doc);
-
-}
-
-
-void printProcessResponse(maps* m,int pid,service* serv,char* service,int status,map* inputs,map* outputs){
-  
-  xmlNsPtr ns,ns_ows,ns_xlink,ns_xsi;
-  xmlNodePtr nr,n,nc,nc1,nc2,nc3,pseudor;
-  xmlDocPtr doc;
-  xmlChar *xmlbuff;
-  int buffersize;
-  time_t time1;  
-  time(&time1);
-  /**
-   * Create the document and its temporary root.
-   */
-  doc = xmlNewDoc(BAD_CAST "1.0");
-  pseudor = xmlNewNode(ns, BAD_CAST "root");
-  ns_ows=xmlNewNs(pseudor,BAD_CAST "http://www.opengis.net/ows/1.1",BAD_CAST "ows");
-  nr = xmlNewNode(ns, BAD_CAST "root");
-  ns=xmlNewNs(nr,BAD_CAST "http://www.opengis.net/wps/1.0.0",BAD_CAST "wps");
-
-  maps* tmp_maps=getMaps(m,"main");
-  if(tmp_maps!=NULL){
-    map* tmp=getMap(tmp_maps->content,"encoding");
-    if(tmp!=NULL){
-      doc->encoding = xmlCharStrdup(tmp->value);
-    }
-    else
-      doc->encoding = xmlCharStrdup("UTF-8");
-  }
-  
-  n = xmlNewNode(ns, BAD_CAST "ExecuteResponse");  
-  xmlNewNs(n,BAD_CAST "http://www.opengis.net/ows/1.1",BAD_CAST "ows");
-  xmlNewNs(n,BAD_CAST "http://www.opengis.net/wps/1.0.0",BAD_CAST "wps");
-  xmlNewNs(n,BAD_CAST "http://www.w3.org/1999/xlink",BAD_CAST "xlink");
-  xmlNewNs(n,BAD_CAST "http://www.w3.org/2001/XMLSchema-instance",BAD_CAST "xsi");
-  xmlNewProp(n,BAD_CAST "xsi:schemaLocation",BAD_CAST "http://www.opengis.net/wps/1.0.0 http://schemas.opengis.net/wps/1.0.0/wpsExecute_response.xsd");
-  xmlNewProp(n,BAD_CAST "service",BAD_CAST "WPS");
-  xmlNewProp(n,BAD_CAST "version",BAD_CAST "1.0.0");
-  xmlNewProp(n,BAD_CAST "xml:lang",BAD_CAST "en");
-  char tmp[256];
-  char url[256];
-  memset(tmp,0,256);
-  memset(url,0,256);
-  if(tmp_maps!=NULL){
-    map* tmpm=getMap(tmp_maps->content,"serverAddress");
-    if(tmpm!=NULL){
-      sprintf(url,"%s/temp/%s_%i.xml",tmpm->value,service,pid);
-      sprintf(tmp,"%s/%s",tmpm->value,service);
-    }
-  }
-
-  //sprintf(tmp,"%s/%s",SERVICE_URL,service);
-  xmlNewProp(n,BAD_CAST "serviceInstance",BAD_CAST tmp);
-  //memset(tmp,0,256);
-  
-  
-  if(status!=SERVICE_SUCCEEDED){
-    xmlNewProp(n,BAD_CAST "statusLocation",BAD_CAST url);
-  }
-
-
-  nc = xmlNewNode(ns, BAD_CAST "Process");
-  map* tmp2=getMap(serv->content,"processVersion");
-
-  if(tmp2!=NULL)
-    xmlNewProp(nc,BAD_CAST "wps:processVersion",BAD_CAST tmp2->value);
-  
-  printDescription(nc,ns_ows,serv->name,serv->content);
-  fflush(stderr);
-
-  xmlAddChild(n,nc);
-
-  nc = xmlNewNode(ns, BAD_CAST "Status");
-  const struct tm *tm;
-  size_t len;
-  time_t now;
-  char *tmp1;
-  
-  now = time ( NULL );
-  tm = localtime ( &now );
-
-  tmp1 = new char[TIME_SIZE];
-
-  len = strftime ( tmp1, TIME_SIZE, "%Y-%m-%dT%I:%M:%SZ", tm );
-
-  switch(status){
-  case SERVICE_SUCCEEDED:
-    xmlNewProp(nc,BAD_CAST "creationTime",BAD_CAST tmp1);
-    nc1 = xmlNewNode(ns, BAD_CAST "ProcessSucceeded");
-    break;
-  case SERVICE_STARTED:
-    xmlNewProp(nc,BAD_CAST "creationTime",BAD_CAST tmp1);
-    nc1 = xmlNewNode(ns, BAD_CAST "ProcessStarted");
-    xmlNewProp(nc1,BAD_CAST "percentCompleted",BAD_CAST "NEED_SERVICE_ACCESS"); 
-    break;
-  case SERVICE_ACCEPTED:
-    xmlNewProp(nc,BAD_CAST "creationTime",BAD_CAST tmp1);
-    nc1 = xmlNewNode(ns, BAD_CAST "ProcessSucceeded");
-    break;
-  case SERVICE_FAILED:
-    nc1 = xmlNewNode(ns, BAD_CAST "ProcessFailed");
-    break;
-  default :
-    printf("error code not know : %i\n",status);
-    exit(1);
-    break;
-  }
-  xmlAddChild(nc,nc1);
-  xmlAddChild(n,nc);
-
-  fprintf(stderr,"printProcessResponse 1\n");
-
-  nc = xmlNewNode(ns, BAD_CAST "DataInputs");
-  int i;
-  map* mcursor=inputs;
-  elements* scursor=serv->inputs;
-  while(mcursor!=NULL && scursor!=NULL){
-    //xmlAddChild(nc,xmlNewComment(BAD_CAST "Here we need to check for input format from metadata"));
-    printIOType(doc,nc,ns,ns_ows,scursor,mcursor,"Input");
-    mcursor=mcursor->next;
-    scursor=scursor->next;
-  }
-  xmlAddChild(n,nc);
-
-  fprintf(stderr,"printProcessResponse 1\n");
-
-  nc = xmlNewNode(ns, BAD_CAST "OutputDefinitions");
-  mcursor=outputs;
-  scursor=serv->outputs;
-  //dumpMap(mcursor);
-  while(mcursor!=NULL && scursor!=NULL){
-    //xmlAddChild(nc,xmlNewComment(BAD_CAST "Here we need to check for output format from metadata"));
-    printOutputDefinitions(doc,nc,ns,ns_ows,scursor,mcursor,"Output");
-    mcursor=mcursor->next;
-    scursor=scursor->next;
-  }
-  xmlAddChild(n,nc);
-
-  fprintf(stderr,"printProcessResponse 1\n");
-  
-  nc = xmlNewNode(ns, BAD_CAST "ProcessOutputs");
-  mcursor=outputs;
-  scursor=serv->outputs;
-  while(mcursor!=NULL && scursor!=NULL){
-    //xmlAddChild(nc,xmlNewComment(BAD_CAST "Here we need to check for output format from metadata"));
-    printIOType(doc,nc,ns,ns_ows,scursor,mcursor,"Output");
-    mcursor=mcursor->next;
-    scursor=scursor->next;
-  }
-  xmlAddChild(n,nc);
-  fprintf(stderr,"printProcessResponse 1\n");
-
-  xmlAddChild(nr,n);
-  xmlDocSetRootElement(doc, n);
-
-  /*
-   * Dump the document to a buffer and print it
-   * for demonstration purposes.
-   */
-  xmlDocDumpFormatMemory(doc, &xmlbuff, &buffersize, 1);
-  printf((char *) xmlbuff);
-  
-  /*
-   * Free associated memory.
-   */
-  xmlFree(xmlbuff);
-  xmlFreeDoc(doc);
-
-}
-
-
-void printGetCapabilitiesResponse(service** serv,int sc,char* service,maps* m){
-
-  xmlNsPtr ns,ns_ows,ns_xlink,ns_xsi;
-  xmlNodePtr nr,n,nc,nc1,nc2,nc3,nc4,nc5,nc6,pseudor;
-  xmlDocPtr doc;
+  xmlNodePtr n,nc,nc1,nc2,nc3,nc4,nc5,nc6,pseudor;
   xmlChar *xmlbuff;
   int buffersize;
@@ -434,26 +150,17 @@
    * Create the document and its temporary root.
    */
-  nr = xmlNewNode(ns, BAD_CAST "root");
-  ns=xmlNewNs(nr,BAD_CAST "http://www.opengis.net/wps/1.0.0",BAD_CAST "wps");
-
+  int wpsId=zooXmlAddNs(NULL,"http://www.opengis.net/wps/1.0.0","wps");
+  ns=usedNs[wpsId];
   maps* toto1=getMaps(m,"main");
-  doc = xmlNewDoc(BAD_CAST "1.0");
-  if(toto1!=NULL){
-    map* tmp=getMap(toto1->content,"encoding");
-    if(tmp!=NULL){
-      doc->encoding = xmlCharStrdup(tmp->value);
-    }
-    else
-      doc->encoding = xmlCharStrdup("UTF-8");
-  }
-  else
-    doc->encoding = xmlCharStrdup ("UTF-8");
-
-  n = xmlNewNode(ns, BAD_CAST "Capabilities");  
-  ns_ows=xmlNewNs(n,BAD_CAST "http://www.opengis.net/ows/1.1",BAD_CAST "ows");
+
+  n = xmlNewNode(ns, BAD_CAST "Capabilities");
+  int owsId=zooXmlAddNs(n,"http://www.opengis.net/ows/1.1","ows");
+  ns_ows=usedNs[owsId];
   xmlNewNs(n,BAD_CAST "http://www.opengis.net/wps/1.0.0",BAD_CAST "wps");
-  xmlNewNs(n,BAD_CAST "http://www.w3.org/1999/xlink",BAD_CAST "xlink");
-  xmlNewNs(n,BAD_CAST "http://www.w3.org/2001/XMLSchema-instance",BAD_CAST "xsi");
-  xmlNewProp(n,BAD_CAST "xsi:schemaLocation",BAD_CAST "http://www.opengis.net/wps/1.0.0 http://schemas.opengis.net/wps/1.0.0/wpsGetCapabilities_response.xsd");
+  int xsiId=zooXmlAddNs(n,"http://www.w3.org/2001/XMLSchema-instance","xsi");
+  ns_xsi=usedNs[xsiId];
+  int xlinkId=zooXmlAddNs(n,"http://www.w3.org/1999/xlink","xlink");
+  ns_xlink=usedNs[xlinkId];
+  xmlNewNsProp(n,ns_xsi,BAD_CAST "schemaLocation",BAD_CAST "http://www.opengis.net/wps/1.0.0 http://schemas.opengis.net/wps/1.0.0/wpsGetCapabilities_response.xsd"); 
   xmlNewProp(n,BAD_CAST "service",BAD_CAST "WPS");
   
@@ -476,315 +183,9 @@
     map* tmp2=tmp4->content;
     while(tmp2!=NULL){
-      if(strcmp(tmp2->name,"keywords")!=0 &&
-	 strcmp(tmp2->name,"serverAddress")!=0 &&
-	 strcmp(tmp2->name,"lang")!=0 &&
-	 strcmp(tmp2->name,"encoding")!=0 &&
-	 strcmp(tmp2->name,"version")!=0){
-	tmp2->name[0]=toupper(tmp2->name[0]);
-	nc1 = xmlNewNode(ns_ows, BAD_CAST tmp2->name);
-	xmlAddChild(nc1,xmlNewText(BAD_CAST tmp2->value));
-	xmlAddChild(nc,nc1);
-      }
-      else
-	if(strcmp(tmp2->name,"keywords")==0){
-	  nc1 = xmlNewNode(ns_ows, BAD_CAST "Keywords");
-	  char *toto=tmp2->value;
-	  char buff[256];
-	  int i=0;
-	  int j=0;
-	  while(toto[i]){
-	    if(toto[i]!=',' && toto[i]!=0){
-	      buff[j]=toto[i];
-	      buff[j+1]=0;
-	      j++;
-	    }
-	    else{
-	      nc2 = xmlNewNode(ns_ows, BAD_CAST "Keyword");
-	      xmlAddChild(nc2,xmlNewText(BAD_CAST buff));	      
-	      xmlAddChild(nc1,nc2);
-	      j=0;
-	    }
-	    i++;
-	  }
-	  if(strlen(buff)>0){
-	    nc2 = xmlNewNode(ns_ows, BAD_CAST "Keyword");
-	    xmlAddChild(nc2,xmlNewText(BAD_CAST buff));	      
-	    xmlAddChild(nc1,nc2);
-	  }
-	  xmlAddChild(nc,nc1);
-	}
-      tmp2=tmp2->next;
-    }
-  }
-  else{
-    fprintf(stderr,"TMP4 NOT FOUND !!");
-    //dumpMaps(tmp4);
-    return;
-  }
-  xmlAddChild(n,nc);
-
-  nc = xmlNewNode(ns_ows, BAD_CAST "ServiceProvider");
-  nc3 = xmlNewNode(ns_ows, BAD_CAST "ServiceContact");
-  nc4 = xmlNewNode(ns_ows, BAD_CAST "ContactInfo");
-  nc5 = xmlNewNode(ns_ows, BAD_CAST "Phone");
-  nc6 = xmlNewNode(ns_ows, BAD_CAST "Address");
-  tmp4=getMaps(m,"provider");
-  if(tmp4!=NULL){
-    map* tmp2=tmp4->content;
-    while(tmp2!=NULL){
-      if(strcmp(tmp2->name,"keywords")!=0 &&
-	 strcmp(tmp2->name,"serverAddress")!=0 &&
-	 strcmp(tmp2->name,"lang")!=0){
-	tmp2->name[0]=toupper(tmp2->name[0]);
-	if(strcmp(tmp2->name,"ProviderName")==0 || 
-	   strcmp(tmp2->name,"ProviderSite")==0){
-	  nc1 = xmlNewNode(ns_ows, BAD_CAST tmp2->name);
-	  xmlAddChild(nc1,xmlNewText(BAD_CAST tmp2->value));
-	  xmlAddChild(nc,nc1);
-	}
-	else{
-	  if(strcmp(tmp2->name,"IndividualName")==0 || 
-	     strcmp(tmp2->name,"PositionName")==0){
-	    nc1 = xmlNewNode(ns_ows, BAD_CAST tmp2->name);
-	    xmlAddChild(nc1,xmlNewText(BAD_CAST tmp2->value));
-	    xmlAddChild(nc3,nc1);
-	  } 
-	  else 
-	    if(strncmp(tmp2->name,"Phone",5)==0){
-	      char *toto=NULL;
-	      char *toto1=tmp2->name;
-	      toto=strstr(toto1,"Phone");
-	      nc1 = xmlNewNode(ns_ows, BAD_CAST toto1+5);
-	      xmlAddChild(nc1,xmlNewText(BAD_CAST tmp2->value));
-	      xmlAddChild(nc5,nc1);
-	    }
-	    else 
-	      if(strncmp(tmp2->name,"Address",7)==0){
-		char *toto=NULL;
-		char *toto1=tmp2->name;
-		toto=strstr(toto1,"Address");
-		nc1 = xmlNewNode(ns_ows, BAD_CAST toto1+7);
-		xmlAddChild(nc1,xmlNewText(BAD_CAST tmp2->value));
-		xmlAddChild(nc6,nc1);
-	      }
-	}
-      }
-      else
-	if(strcmp(tmp2->name,"keywords")==0){
-	  nc1 = xmlNewNode(ns_ows, BAD_CAST "Keywords");
-	  char *toto=tmp2->value;
-	  char buff[256];
-	  int i=0;
-	  int j=0;
-	  while(toto[i]){
-	    if(toto[i]!=',' && toto[i]!=0){
-	      buff[j]=toto[i];
-	      buff[j+1]=0;
-	      j++;
-	    }
-	    else{
-	      nc2 = xmlNewNode(ns_ows, BAD_CAST "Keyword");
-	      xmlAddChild(nc2,xmlNewText(BAD_CAST buff));	      
-	      xmlAddChild(nc1,nc2);
-	      j=0;
-	    }
-	    i++;
-	  }
-	  if(strlen(buff)>0){
-	    nc2 = xmlNewNode(ns_ows, BAD_CAST "Keyword");
-	    xmlAddChild(nc2,xmlNewText(BAD_CAST buff));	      
-	    xmlAddChild(nc1,nc2);
-	  }
-	  xmlAddChild(nc,nc1);
-	}
-      tmp2=tmp2->next;
-    }
-  }
-  else{
-    fprintf(stderr,"TMP4 NOT FOUND !!");
-    //dumpMaps(tmp4);
-  }
-  xmlAddChild(nc4,nc5);
-  xmlAddChild(nc4,nc6);
-  xmlAddChild(nc3,nc4);
-  xmlAddChild(nc,nc3);
-  xmlAddChild(n,nc);
-
-
-  nc = xmlNewNode(ns_ows, BAD_CAST "OperationsMetadata");
-  char *tmp2[3];
-  tmp2[0]="GetCapabilities";
-  tmp2[1]="DescribeProcess";
-  tmp2[2]="Execute";
-  int j=0;
-
-
-  for(j=0;j<3;j++){
-    nc1 = xmlNewNode(ns_ows, BAD_CAST "Operation");
-    xmlNewProp(nc1,BAD_CAST "name",BAD_CAST tmp2[j]);
-    nc2 = xmlNewNode(ns_ows, BAD_CAST "DCP");
-    nc3 = xmlNewNode(ns_ows, BAD_CAST "HTTP");
-    nc4 = xmlNewNode(ns_ows, BAD_CAST "Get");
-    sprintf(tmp,"%s/%s",SERVICE_URL,service);
-    xmlNewProp(nc4,BAD_CAST "xlink:href",BAD_CAST tmp);
-    xmlAddChild(nc3,nc4);
-    if(j>0){
-      nc4 = xmlNewNode(ns_ows, BAD_CAST "Post");
-      xmlNewProp(nc4,BAD_CAST "xlink:href",BAD_CAST tmp);
-      xmlAddChild(nc3,nc4);
-    }
-    xmlAddChild(nc2,nc3);
-    xmlAddChild(nc1,nc2);    
-    xmlAddChild(nc,nc1);    
-  }
-  xmlAddChild(n,nc);
-
-
-  nc = xmlNewNode(ns, BAD_CAST "ProcessOfferings");
-  /**
-   * Need to loop over various operations
-   */
-  int cursor=0;
-  map* tmp1;
-  for(cursor=0;cursor<sc;cursor++){
-    //dumpService(serv[cursor]);
-    if(serv[cursor]->content!=NULL){
-      nc1 = xmlNewNode(ns, BAD_CAST "Process");
-      tmp1=getMap(serv[cursor]->content,"processVersion");
-      if(tmp1!=NULL)
-	xmlNewProp(nc1,BAD_CAST "wps:processVersion",BAD_CAST tmp1->value);
-      
-      printDescription(nc1,ns_ows,serv[cursor]->name,serv[cursor]->content);
-      tmp1=serv[cursor]->metadata;
-      while(tmp1!=NULL){
-	nc2 = xmlNewNode(ns_ows, BAD_CAST "Metadata");
-	xmlNewProp(nc2,BAD_CAST tmp1->name,BAD_CAST tmp1->value);
-	xmlAddChild(nc1,nc2);
-	tmp1=tmp1->next;
-      }
-      xmlAddChild(nc,nc1);
-      xmlAddChild(n,nc);
-    }
-  }
-
-
-  nc1 = xmlNewNode(ns, BAD_CAST "Languages");
-  nc2 = xmlNewNode(ns, BAD_CAST "Default");
-  nc3 = xmlNewNode(ns, BAD_CAST "Supported");
-  
-  toto1=getMaps(m,"main");
-  if(toto1!=NULL){
-    tmp1=getMap(toto1->content,"lang");
-    char *toto=tmp1->value;
-    char buff[256];
-    int i=0;
-    int j=0;
-    int dcount=0;
-    while(toto[i]){
-      if(toto[i]!=',' && toto[i]!=0){
-	buff[j]=toto[i];
-	buff[j+1]=0;
-	j++;
-      }
-      else{
-	nc4 = xmlNewNode(ns_ows, BAD_CAST "Language");
-	xmlAddChild(nc4,xmlNewText(BAD_CAST buff));
-	if(dcount==0){
-	  xmlAddChild(nc2,nc4);
-	  xmlAddChild(nc1,nc2);
-	  xmlNewProp(n,BAD_CAST "xml:lang",BAD_CAST buff);
-	  dcount++;
-	}
-	nc4 = xmlNewNode(ns_ows, BAD_CAST "Language");
-	xmlAddChild(nc4,xmlNewText(BAD_CAST buff));
-	xmlAddChild(nc3,nc4);
-	j=0;
-	buff[j]=0;
-      }
-      i++;
-    }
-    if(strlen(buff)>0){
-      nc4 = xmlNewNode(ns_ows, BAD_CAST "Language");
-      xmlAddChild(nc4,xmlNewText(BAD_CAST buff));	      
-      xmlAddChild(nc3,nc4);
-    }
-  }
-  xmlAddChild(nc1,nc3);
-  xmlAddChild(n,nc1);
-  
-  xmlDocSetRootElement(doc, n);
-    
-  /*
-   * Dump the document to a buffer and print it
-   * for demonstration purposes.
-   */
-  xmlDocDumpFormatMemory(doc, &xmlbuff, &buffersize, 1);
-  printf((char *) xmlbuff);
-  
-  /*
-   * Free associated memory.
-   */
-  xmlFree(xmlbuff);
-  //xmlFreeDoc(doc);
-
-}
-
-xmlNodePtr printGetCapabilitiesHeader(xmlDocPtr doc,char* service,maps* m){
-
-  xmlNsPtr ns,ns_ows,ns_xlink,ns_xsi;
-  xmlNodePtr nr,n,nc,nc1,nc2,nc3,nc4,nc5,nc6,pseudor;
-  //xmlDocPtr doc;
-  xmlChar *xmlbuff;
-  int buffersize;
-  /**
-   * Create the document and its temporary root.
-   */
-  nr = xmlNewNode(ns, BAD_CAST "root");
-  ns=xmlNewNs(nr,BAD_CAST "http://www.opengis.net/wps/1.0.0",BAD_CAST "wps");
-
-  maps* toto1=getMaps(m,"main");
-  //doc = xmlNewDoc(BAD_CAST "1.0");
-  if(toto1!=NULL){
-    map* tmp=getMap(toto1->content,"encoding");
-    if(tmp!=NULL){
-      doc->encoding = xmlCharStrdup(tmp->value);
-    }
-    else
-      doc->encoding = xmlCharStrdup("UTF-8");
-  }
-  else
-    doc->encoding = xmlCharStrdup ("UTF-8");
-
-  n = xmlNewNode(ns, BAD_CAST "Capabilities");  
-  ns_ows=xmlNewNs(n,BAD_CAST "http://www.opengis.net/ows/1.1",BAD_CAST "ows");
-  xmlNewNs(n,BAD_CAST "http://www.opengis.net/wps/1.0.0",BAD_CAST "wps");
-  xmlNewNs(n,BAD_CAST "http://www.w3.org/1999/xlink",BAD_CAST "xlink");
-  xmlNewNs(n,BAD_CAST "http://www.w3.org/2001/XMLSchema-instance",BAD_CAST "xsi");
-  xmlNewProp(n,BAD_CAST "xsi:schemaLocation",BAD_CAST "http://www.opengis.net/wps/1.0.0 http://schemas.opengis.net/wps/1.0.0/wpsGetCapabilities_response.xsd");
-  xmlNewProp(n,BAD_CAST "service",BAD_CAST "WPS");
-  
-  if(toto1!=NULL){
-    map* tmp=getMap(toto1->content,"version");
-    if(tmp!=NULL){
-      xmlNewProp(n,BAD_CAST "version",BAD_CAST tmp->value);
-    }
-    else
-      xmlNewProp(n,BAD_CAST "version",BAD_CAST "1.0.0");
-  }
-  else
-    xmlNewProp(n,BAD_CAST "version",BAD_CAST "1.0.0");
-
-  char tmp[256];
-  
-  nc = xmlNewNode(ns_ows, BAD_CAST "ServiceIdentification");
-  maps* tmp4=getMaps(m,"identification");
-  if(tmp4!=NULL){
-    map* tmp2=tmp4->content;
-    while(tmp2!=NULL){
-      if(strcmp(tmp2->name,"keywords")!=0 &&
-	 strcmp(tmp2->name,"serverAddress")!=0 &&
-	 strcmp(tmp2->name,"lang")!=0 &&
-	 strcmp(tmp2->name,"encoding")!=0 &&
-	 strcmp(tmp2->name,"version")!=0){
+      if(strncasecmp(tmp2->name,"keywords",8)!=0 &&
+	 strncasecmp(tmp2->name,"serverAddress",13)!=0 &&
+	 strncasecmp(tmp2->name,"lang",4)!=0 &&
+	 strncasecmp(tmp2->name,"encoding",8)!=0 &&
+	 strncasecmp(tmp2->name,"version",7)!=0){
 	tmp2->name[0]=toupper(tmp2->name[0]);
 	nc1 = xmlNewNode(ns_ows, BAD_CAST tmp2->name);
@@ -857,5 +258,5 @@
 	  if(strcmp(tmp2->name,"ProviderSite")==0){
 	    nc1 = xmlNewNode(ns_ows, BAD_CAST tmp2->name);
-	    xmlNewProp(nc1,BAD_CAST "xlink:href",BAD_CAST tmp2->value);
+	    xmlNewNsProp(nc1,ns_xlink,BAD_CAST "href",BAD_CAST tmp2->value);
 	    xmlAddChild(nc,nc1);
 	  } 
@@ -931,7 +332,7 @@
   nc = xmlNewNode(ns_ows, BAD_CAST "OperationsMetadata");
   char *tmp2[3];
-  tmp2[0]="GetCapabilities";
-  tmp2[1]="DescribeProcess";
-  tmp2[2]="Execute";
+  tmp2[0]=strdup("GetCapabilities");
+  tmp2[1]=strdup("DescribeProcess");
+  tmp2[2]=strdup("Execute");
   int j=0;
 
@@ -942,8 +343,8 @@
     }
     else
-      SERVICE_URL = "not_found";
+      SERVICE_URL = strdup("not_found");
   }
   else
-    SERVICE_URL = "not_found";
+    SERVICE_URL = strdup("not_found");
 
   for(j=0;j<3;j++){
@@ -954,9 +355,9 @@
     nc4 = xmlNewNode(ns_ows, BAD_CAST "Get");
     sprintf(tmp,"%s/%s",SERVICE_URL,service);
-    xmlNewProp(nc4,BAD_CAST "xlink:href",BAD_CAST tmp);
+    xmlNewNsProp(nc4,ns_xlink,BAD_CAST "href",BAD_CAST tmp);
     xmlAddChild(nc3,nc4);
     if(j>0){
       nc4 = xmlNewNode(ns_ows, BAD_CAST "Post");
-      xmlNewProp(nc4,BAD_CAST "xlink:href",BAD_CAST tmp);
+      xmlNewNsProp(nc4,ns_xlink,BAD_CAST "href",BAD_CAST tmp);
       xmlAddChild(nc3,nc4);
     }
@@ -965,10 +366,10 @@
     xmlAddChild(nc,nc1);    
   }
+  for(j=2;j>=0;j--)
+    free(tmp2[j]);
   xmlAddChild(n,nc);
 
   nc = xmlNewNode(ns, BAD_CAST "ProcessOfferings");
   xmlAddChild(n,nc);
-
-
 
   nc1 = xmlNewNode(ns, BAD_CAST "Languages");
@@ -1017,16 +418,21 @@
   
   xmlDocSetRootElement(doc, n);
-
+  //xmlFreeNs(ns);
+  free(SERVICE_URL);
   return nc;
 }
 
 void printGetCapabilitiesForProcess(maps* m,xmlNodePtr nc,service* serv){
-
-  xmlNsPtr ns,ns_ows;
+  xmlNsPtr ns,ns_ows,ns_xlink;
   xmlNodePtr nr,n,nc1,nc2,nc3,nc4,nc5,nc6,pseudor;
-
-  nr = xmlNewNode(ns, BAD_CAST "root");
-  ns=xmlNewNs(nr,BAD_CAST "http://www.opengis.net/wps/1.0.0",BAD_CAST "wps");
-  ns_ows=xmlNewNs(nr,BAD_CAST "http://www.opengis.net/ows/1.1.0",BAD_CAST "ows");
+  /**
+   * Initialize or get existing namspaces
+   */
+  int wpsId=zooXmlAddNs(NULL,"http://www.opengis.net/wps/1.0.0","wps");
+  ns=usedNs[wpsId];
+  int owsId=zooXmlAddNs(NULL,"http://www.opengis.net/ows/1.1","ows");
+  ns_ows=usedNs[owsId];
+  int xlinkId=zooXmlAddNs(n,"http://www.w3.org/1999/xlink","xlink");
+  ns_xlink=usedNs[xlinkId];
 
   int cursor=0;
@@ -1036,13 +442,10 @@
     tmp1=getMap(serv->content,"processVersion");
     if(tmp1!=NULL)
-      xmlNewProp(nc1,BAD_CAST "wps:processVersion",BAD_CAST tmp1->value);
-    
+      xmlNewNsProp(nc1,ns,BAD_CAST "processVersion",BAD_CAST tmp1->value);
     printDescription(nc1,ns_ows,serv->name,serv->content);
     tmp1=serv->metadata;
     while(tmp1!=NULL){
       nc2 = xmlNewNode(ns_ows, BAD_CAST "Metadata");
-      char toto[1024];
-      sprintf(toto,"xlink:%s",tmp1->name);
-      xmlNewProp(nc2,BAD_CAST toto,BAD_CAST tmp1->value);
+      xmlNewNsProp(nc2,ns_xlink,BAD_CAST tmp1->name,BAD_CAST tmp1->value);
       xmlAddChild(nc1,nc2);
       tmp1=tmp1->next;
@@ -1050,70 +453,47 @@
     xmlAddChild(nc,nc1);
   }
-  
-}
-
-void printDocument(xmlDocPtr doc){
-  rewind(stdout);
-  printf("Content-Type: text/xml; charset=utf-8\r\nStatus: 200 OK\r\n\r\n");
-  fflush(stdout);
+}
+
+xmlNodePtr printDescribeProcessHeader(xmlDocPtr doc,char* service,maps* m){
+
+  xmlNsPtr ns,ns_ows,ns_xlink,ns_xsi;
+  xmlNodePtr n,nr;
   xmlChar *xmlbuff;
   int buffersize;
-  /*
-   * Dump the document to a buffer and print it on stdout
-   * for demonstration purposes.
-   */
-  xmlDocDumpFormatMemory(doc, &xmlbuff, &buffersize, 1);
-  printf((char *) xmlbuff);
-  /*
-   * Free associated memory.
-   */
-  xmlFree(xmlbuff);
-  xmlFreeDoc(doc);
-}
-
-void printGetCapabilitiesDocument(xmlDocPtr doc){
-  printf("Content-Type: text/xml; charset=utf-8\r\nStatus: 200 OK\r\n\r\n");
-  xmlChar *xmlbuff;
-  int buffersize;
-  /*
-   * Dump the document to a buffer and print it on stdout
-   * for demonstration purposes.
-   */
-  xmlDocDumpFormatMemory(doc, &xmlbuff, &buffersize, 1);
-  printf((char *) xmlbuff);
-  /*
-   * Free associated memory.
-   */
-  xmlFree(xmlbuff);
-
-}
+
+  int wpsId=zooXmlAddNs(NULL,"http://schemas.opengis.net/wps/1.0.0","wps");
+  ns=usedNs[wpsId];
+  n = xmlNewNode(ns, BAD_CAST "ProcessDescriptions");
+  int owsId=zooXmlAddNs(n,"http://www.opengis.net/ows/1.1","ows");
+  ns_ows=usedNs[owsId];
+  xmlNewNs(n,BAD_CAST "http://www.opengis.net/wps/1.0.0",BAD_CAST "wps");
+  zooXmlAddNs(n,"http://www.w3.org/1999/xlink","xlink");
+  int xsiId=zooXmlAddNs(n,"http://www.w3.org/2001/XMLSchema-instance","xsi");
+  ns_xsi=usedNs[xsiId];
   
-
-void printDescribeProcessResponse(service* serv,char* service){
-
-  xmlNsPtr ns,ns_ows,ns_xlink,ns_xsi;
-  xmlNodePtr nr,n,nc,nc1,nc2,nc3,nc4,nc5,nc6,pseudor;
-  xmlDocPtr doc;
-  xmlChar *xmlbuff;
-  int buffersize;
-  /**
-   * Create the document and its temporary root.
-   */
-  nr = xmlNewNode(ns, BAD_CAST "root");
-  ns=xmlNewNs(nr,BAD_CAST "http://schemas.opengis.net/wps/1.0.0",BAD_CAST "wps");
-
-  doc = xmlNewDoc(BAD_CAST "1.0");
-  doc->encoding = xmlCharStrdup ("UTF-8");
-
-  n = xmlNewNode(ns, BAD_CAST "ProcessDescriptions");  
-  ns_ows=xmlNewNs(n,BAD_CAST "http://www.opengis.net/ows/1.1",BAD_CAST "ows");
-  xmlNewNs(n,BAD_CAST "http://www.opengis.net/wps/1.0.0",BAD_CAST "wps");
-  xmlNewNs(n,BAD_CAST "http://www.w3.org/1999/xlink",BAD_CAST "xlink");
-  xmlNewNs(n,BAD_CAST "http://www.w3.org/2001/XMLSchema-instance",BAD_CAST "xsi");
-  xmlNewProp(n,BAD_CAST "xsi:schemaLocation",BAD_CAST "http://www.opengis.net/wps/1.0.0 http://schemas.opengis.net/wps/1.0.0/wpsDescribeProcess_response.xsd");
+  xmlNewNsProp(n,ns_xsi,BAD_CAST "schemaLocation",BAD_CAST "http://www.opengis.net/wps/1.0.0 http://schemas.opengis.net/wps/1.0.0/wpsDescribeProcess_response.xsd");
   xmlNewProp(n,BAD_CAST "service",BAD_CAST "WPS");
   xmlNewProp(n,BAD_CAST "version",BAD_CAST "1.0.0");
+  xmlNewProp(n,BAD_CAST "xml:lang",BAD_CAST "en");
+
+  xmlDocSetRootElement(doc, n);
+
+  return n;
+}
+
+void printDescribeProcessForProcess(maps* m,xmlNodePtr nc,service* serv,int sc){
+  xmlNsPtr ns,ns_ows,ns_xlink,ns_xsi;
+  xmlNodePtr nr,n,nc1,nc2,nc3,nc4,nc5,nc6,pseudor;
+
   char tmp[256];
+  n=nc;
   
+  int wpsId=zooXmlAddNs(NULL,"http://schemas.opengis.net/wps/1.0.0","wps");
+  ns=usedNs[wpsId];
+  int owsId=zooXmlAddNs(NULL,"http://www.opengis.net/ows/1.1","ows");
+  ns_ows=usedNs[owsId];
+  int xlinkId=zooXmlAddNs(NULL,"http://www.w3.org/1999/xlink","xlink");
+  ns_xlink=usedNs[xlinkId];
+
   nc = xmlNewNode(NULL, BAD_CAST "ProcessDescription");
   char *tmp4[3];
@@ -1127,5 +507,5 @@
     if(tmp1!=NULL){
       if(j==0)
-	xmlNewProp(nc,BAD_CAST "wps:processVersion",BAD_CAST tmp1->value);      
+	xmlNewNsProp(nc,ns,BAD_CAST "processVersion",BAD_CAST tmp1->value);      
       else
 	xmlNewProp(nc,BAD_CAST tmp4[j],BAD_CAST tmp1->value);      
@@ -1142,5 +522,5 @@
   while(tmp1!=NULL){
     nc1 = xmlNewNode(ns_ows, BAD_CAST "Metadata");
-    xmlNewProp(nc1,BAD_CAST tmp1->name,BAD_CAST tmp1->value);
+    xmlNewNsProp(nc1,ns_xlink,BAD_CAST tmp1->name,BAD_CAST tmp1->value);
     xmlAddChild(nc,nc1);
     tmp1=tmp1->next;
@@ -1173,5 +553,7 @@
     nc3 = xmlNewNode(NULL, BAD_CAST e->format);
     iotype* _tmp=e->defaults;
+    int datatype=0;
     if(_tmp!=NULL){
+      int isAnyValue=1;
       if(strcmp(e->format,"LiteralData")!=0){
 	nc4 = xmlNewNode(NULL, BAD_CAST "Default");
